Attribute VB_Name = "mod_main"
Option Explicit

'Programm object
      Public mdi As frm_MDI
      
'Einstellungs object
      Public Opt As frm_OPT
      
'CDraw object
      Public CDraw As cls_CDraw

'CommonDialog object
      Public CDlg As cls_ComDlg
      
'Chart object
      Public FChart As frm_CHART
      Public iCIndex As Integer

'Chart Default
  'siehe mod_ini

'Enum Chart Funktionen
      Public Enum enmChart
          CNeu = 0
          CClear
          CKill
          CRefresh
          CDruck
          CMPunkte
          CHDatum
          CHColor
          COptionen
          CLegende
          COpen
          COpen2
          CYScroll
          CXScroll
          CHScroll
          End Enum

      Public Enum enmTBChk
          Punkte = 0
          DATUM
          Legende
          End Enum
          
'Chart Funktionen
      Sub MainProzess(fnk As enmChart, ParamArray PArray())
        Dim b&, h&, c&, dat$, rhdc As Long, ObjKey As String ', flags As Long
        On Error Resume Next
          Select Case fnk
          
  'Chart YScroll
          Case enmChart.CYScroll
                mdi.ActiveForm.YIntervall CInt(PArray(0))
                MainProzess CRefresh
                
  'Chart XScroll
          Case enmChart.CXScroll
                mdi.ActiveForm.XMaxScroll CInt(PArray(0))
                MainProzess CRefresh
                
  'Chart HScroll
          Case enmChart.CHScroll
                mdi.ActiveForm.XMinScroll CInt(PArray(0))
                MainProzess CRefresh
       
  'Dateien ffnen
          Case enmChart.COpen
                OpenTxtFile , , mdi.TBar(TBar.TBopen).ToolTipText
                MainProzess CRefresh
                
  'Dateien ffnen
          Case enmChart.COpen2
                OpenTxtFile , 1, mdi.TBar(TBar.TBopen2).ToolTipText
                MainProzess CRefresh
                
  'Optionen
          Case enmChart.COptionen
                Optionen
                MainProzess CRefresh
  
  'Chart HColor
          Case enmChart.CHColor
                If Forms.Count = 1 Then Exit Sub
                c& = ShowColor
                If c& <> 0 Then
                    mdi.ActiveForm.BackColor = c&
                    CDraw.ACRefresh
                End If
                
  'Chart Messpunkte
          Case enmChart.CMPunkte
                If Forms.Count = 1 Then Exit Sub
                MainProzess CRefresh
                
  'Chart HDatum
          Case enmChart.CHDatum
                If Forms.Count = 1 Then Exit Sub
                iniHDatum = mdi.TBChk(enmTBChk.DATUM).Value
                MainProzess CRefresh
  
  'Chart Legende
          Case enmChart.CLegende
                If Forms.Count = 1 Then Exit Sub
                iniLegende = mdi.TBChk(enmTBChk.Legende).Value
                MainProzess CRefresh
                
  'Chart hinzufgen
          Case enmChart.CNeu
                Set FChart = New frm_CHART
                Load FChart
                FChart.iCIndex = iCIndex
                FChart.Caption = "Chart" & Str(iCIndex)
                FChart.lCht_YMaxVal = iniYLgdMax
                'FChart.lCht_YMaxVal = IIf(FChart.lCht_YMaxVal = 500, iniYLgdMax, FChart.lCht_YMaxVal)
                iCIndex = iCIndex + 1
                iniFormConfig FChart.lbLegend, False
                MainProzess CRefresh
                
  'ActiveChart cls
          Case enmChart.CClear
                If Forms.Count = 1 Then Exit Sub
                ActiveChart
                CDraw.LineDrop 'alle Line lschen

  'ActiveChart Kill
          Case enmChart.CKill
                If Forms.Count = 1 Then Exit Sub
                Unload mdi.ActiveForm
            
  'ActiveChart Refresh
          Case enmChart.CRefresh
                If Forms.Count = 1 Then Exit Sub
                With mdi.ActiveForm
                .sCht_Titel = iniTitel
                .sCht_XLName = iniXLegende
                .sCht_YLName = iniYLegende
                
                .BackColor = iniCBColor
                .bHDatum = iniHDatum
                .Legende = iniLegende
                '.bLegende = iniLegende
                .lCht_MWXBeginn = IIf(iniMPeriode, 1, 0)
                .bMPunkte = mdi.TBChk(enmTBChk.Punkte).Value
                
                  ActiveChart
                  CDraw.ACColAuto
                ' mdi  Steuerung
                  mdi.HScroll.min = .iCht_XMaxValScroll
                  mdi.XScroll.VISIBLE = IIf(.iCht_XMaxValVirtuel > .iCht_XMinVal, True, False)
                  mdi.HScroll.VISIBLE = mdi.XScroll.VISIBLE
                
                End With
                ActiveChart
                CDraw.ACRefresh

  'ActiveChart Print
          Case enmChart.CDruck
               ActiveChart
               Set CDlg = New cls_ComDlg
              ' On Error Resume Next
               With CDlg  ' Drucker auswhlen / konfigurieren
                   .flags = &H100 + &H40 + &H800
                   .Copies = 0: .FromPage = 0: .ToPage = 0: .Max = 0: .min = 0
                   .CancelError = True
                   .PrinterDefault = False
                   If Not .ShowPrinter(rhdc) Then Exit Sub
                   If .flags And &H20 Then  ' in Datei drucken
                       If .ShowSelect(rhdc, dat, "*.prn", "Ausdruck in Datei") Then GoTo err
                       .Output = dat
                   Else
                       .Output = vbNullString
                   End If
                   If Not .PageSizeOpen(h, b, rhdc, , App.ProductName & Date) Then
                     CDraw.ACPrint rhdc 'auf Drucker zeichnen
                     .PageSizeClose rhdc
                   End If
               End With
               Set CDlg = Nothing

          End Select
          
err:      mErrorMsg 0
          Set FChart = Nothing
          End Sub
          
  'ActiveChart setzen
      Public Sub ActiveChart()
            On Error Resume Next
            If mdi.ActiveForm Is Nothing Then MainProzess CNeu
            With mdi.ActiveForm
            CDraw.ACSet mdi.ActiveForm, .lHeight, .lWidth
            End With
            End Sub

  'Linie hinzufgen
      Public Sub ChartLineAdd(ByRef fDatum As Date, fZeitR As Variant, FileName As String, Optional Cls)
            ActiveChart
            CDraw.LineAdd fDatum, fZeitR, FileName
            End Sub


'Programm Start
      Public Sub Main()
          INI_Initiale
          Set mdi = New frm_MDI
          iniFormConfig mdi, False
          TBar_ini
          InitialeAppl
          mdi.Show
          MainProzess CNeu
          ShowInfo 1
          End Sub
          
''Programm info
'      Public Sub ShowInfo()
'          Set CDlg = New cls_ComDlg
'          CDlg.hdc = mdi.hWnd
'          CDlg.ShowInfo
'          Set CDlg = Nothing
'          End Sub

      Public Sub ShowInfo(Optional ok)
          Dim Info As New frm_Start
          If IsMissing(ok) Then
            Info.ShowInfo mdi, True
          Else
            Info.ShowInfo mdi, False
          End If
          Set Info = Nothing
          End Sub
          
      Public Sub ShowHelp()
          Dim Result&
            Result = ShellExecute(mdi.hWnd, "Open", _
            App.HelpFile, "", App.Path, 1)
          End Sub
     

'Programm beenden
      Public Sub Exit_App()
          Set CDraw = Nothing
          If mdi.WindowState = vbNormal Then iniFormConfig mdi, True
          If Not mdi.ActiveForm Is Nothing Then iniFormConfig mdi.ActiveForm.lbLegend, True
          INI_Terminate
          Unload mdi
          End
          End Sub

'Programm Initiale
      Public Sub InitialeAppl()
          Set CDraw = New cls_CDraw
          CDraw.lDLColor = inilDLColor
          mdi.Timer.Interval = 1000   'Timer
          Automat 1                   'Automatik
          End Sub
          
'Dateien ffnen
     Public Sub OpenTxtFile(Optional Files, Optional Anhngen, Optional Titel)
          Dim i, File, fZeitR() As Long, fDatum As Date
          Dim ImpTxt As cls_Import_txt
          On Error GoTo err
          ReDim fZeitR(0)
          If IsMissing(Files) Then If Not FilesOpen(iniDatenPath, Files, Titel) Then Exit Sub
            Set ImpTxt = New cls_Import_txt
            For i = 1 To UBound(Files)
                If ImpTxt.ReadFile(fDatum, fZeitR, (Files(0) & "\" & Files(i)), Anhngen) Then GoTo err
                If IsMissing(Anhngen) Then ChartLineAdd fDatum, fZeitR, (Files(i))
          Next
          If Not IsMissing(Anhngen) Then ChartLineAdd fDatum, fZeitR, (Files(1))
err:      mErrorMsg 1
          End Sub

'sub Dateien ffnen
      Public Function FilesOpen(ByVal FilePath As String, ByRef Files, Optional Titel) As Boolean
          Dim FileName As String
          If IsMissing(Titel) Then Titel = "Multiselect File"
          Set CDlg = New cls_ComDlg
          With CDlg
            If Not .ShowOpen(mdi.hWnd, FileName, "*.txt (Textdateien)|*.txt", Titel, FilePath, 1) Then
              FilesOpen = False
            Else
              Files = String2Array(FileName, vbNullChar)
              If UBound(Files) < 1 Then
                ReDim Preserve Files(1)
                Files(1) = Mid$(Files(0), InStrRev(Files(0), "\") + 1, 100)
                Files(0) = Mid$(Files(0), 1, Len(Files(0)) - Len(Files(1)) - 1)
              End If
              FilesOpen = True
            End If
          End With
          Set CDlg = Nothing
          End Function
          
'Get ColorDialog
      Public Function ShowColor() As Long
          Set CDlg = New cls_ComDlg
          With CDlg
          .hdc = mdi.hWnd
          ShowColor = CDlg.ShowColor
          End With
          Set CDlg = Nothing
      End Function

'Get ShowSelect
      Public Function ShowSelect() As String
          Set CDlg = New cls_ComDlg
          With CDlg
          .hdc = mdi.hWnd
          ShowSelect = CDlg.ShowSelect(, ShowSelect)
          End With
          Set CDlg = Nothing
      End Function
      
'Automatik
      Public Sub Automatik_start()
          Dim i, Tage%, Files(), File, fZeitR(), fDatum As Date, col%
          On Error Resume Next
          fDatum = Now '"04.01.2004"
          ZeitToCol col%, Now
          Tage% = iniATage + 1
          ReDim Files(Tage%)
          Files(0) = iniDatenPath
          For i = 1 To Tage%
            Files(i) = Format(fDatum - Tage% + i, iniDateiFormat)
          Next
          MainProzess CClear
          OpenTxtFile Files, 1
             mdi.ActiveForm.XMaxScroll 1, 1
          MainProzess CRefresh
          mdi.HScroll.Value = col% + 4
          End Sub

'Automatik ein / aus
      Public Sub Automat(Optional init)
          If IsMissing(init) Then iniAutomatik = Not iniAutomatik
          mdi.mnu_extras_sub(smnuExtras.Automatik).Checked = iniAutomatik
          mdi.Timer.Enabled = iniAutomatik
          mdi.lbAStatus.BackColor = &H8000000F
          mdi.sbStatusBar.Caption = ""
          'mdi.Caption = App.ProductName
          End Sub

'Automatik Timer
      Public Sub AutomatTimer()
          Static bAStatus As Boolean
          Static iToffs As Integer
          Dim dTime As Date
          bAStatus = Not bAStatus
          If iToffs = 0 Then iToffs = 9999
          mdi.lbAStatus.BackColor = IIf(bAStatus, RGB(256, 0, 0), RGB(256, 256, 0))
          dTime = Time
          If val(Right(Format(dTime, "hh:mm"), 2)) Mod 15 = 0 And _
             val(Right(Format(dTime, "hh:mm:ss"), 2)) = 0 Then: iToffs = 0
          If iToffs = iniToffs Then Automatik_start
          iToffs = iToffs + 1
          mdi.sbStatusBar.VISIBLE = False
          mdi.sbStatusBar.Caption = "Datum: " & Now
          mdi.sbStatusBar.VISIBLE = True
          End Sub






