Attribute VB_Name = "Module1"
Public Declare Function WritePrivateProfileString Lib "kernel32" _
       Alias "WritePrivateProfileStringA" (ByVal lpApplicationName _
       As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal _
       lpFileName As String) As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" _
       Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, _
       ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal _
       lpReturnedString As String, ByVal nsize As Long, ByVal _
       lpFileName As String) As Long
' X-Achsen Parameter
Global XLinecolor As Long
Global Xfontname As String
Global XFontsize As Integer
Global XFontColor As Long
Global XFontbold As Boolean
Global XFontUnderline As Boolean
Global XFontItalic As Boolean
Global XUhrzeit As Boolean
'Y-Achsen Parameter
Global YLinecolor As Long
Global Yfontname As String
Global YFontsize As Integer
Option Explicit
Global YFontColor As Long
Global YFontbold As Boolean
Global YFontUnderline As Boolean
Global YFontItalic As Boolean
Global MaxY As Long                     ' grter Wert d. Y-Skala
Global Automatic As Boolean             ' Automatisch Skalieren

Global HLcolor As Long
Global WLineColor As Long
Global WPointColor As Long
Global Dateipfad As String

Private Function check0(cstring As String) As String
cstring = RTrim$(cstring)
If Right$(cstring, 1) = Chr$(0) Then
    check0 = RTrim$(Left$(cstring, Len(cstring) - 1))
Else
    check0 = RTrim$(cstring)
End If
End Function

Function leseinidatei(Abschnitt As String, Schluessel As String, default As String) As String
Dim Inidatei As String
Dim Eintrag As String
Dim Anzahl As Long
Inidatei = Trim$(App.Path) + "\" + App.EXEName + ".INI"
Anzahl = 255
Eintrag = Space$(255)
Anzahl = GetPrivateProfileString(Abschnitt, Schluessel, default, Eintrag, Anzahl, Inidatei$)
leseinidatei = check0(Eintrag)
End Function

Sub write2ini(Abschnitt As String, Schluessel As String, Eintrag As String)
Dim Inidatei As String
Inidatei = Trim$(App.Path) + "\" + App.EXEName + ".INI"
Call WritePrivateProfileString(Abschnitt, Schluessel, Eintrag, Inidatei)
End Sub
