Attribute VB_Name = "modMain"
'**************************MAIN FORM***********************************
'Das Hauptmodul!
'Public API's, Public typen, Public subs, Public Variablen sind hier gespeichert...
'**********************************************************************

Public Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Public Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long

Public Type PointAPI 'PointAPI-Type, wird benutzt um Positionen zu speichern
  x As Single
  y As Single
End Type

Public Type RECT 'Rect-Type wird ebenfalls dazu benutzt um Positionen zu speichern, bei diesem Projekt allerdings wird dieser type nur bei einer Variable in der DrawTextEx Sub verwendet
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Public Sub DrawTextEx(Control As Object, x As Long, y As Long, Text, Optional Width As Single, Optional Height As Single) 'Zeichnet einen Text auf eine Picturebox
Dim tmprct As RECT 'Rect deklarieren
tmprct.Bottom = y + Height 'Bottom Wert des Rect's festlegen
tmprct.Right = x + Width 'Right Wert des Rect's festlegen
If Width = 0 Then tmprct.Right = x + Control.TextWidth(Text): Width = Control.TextWidth(Text) 'Falls kein Width wert angegeben wurde, Width automatisch anpassen
If Height = 0 Then tmprct.Bottom = y + Control.TextHeight(Text): Height = Control.TextHeight(Text) 'Das gleiche bei Height
tmprct.Left = x 'Left Wert des Rect's festlegen
tmprct.Top = y 'Top Wert des Rect's festlegen
DrawText Control.hdc, Text, Len(Text), tmprct, 0 'Api fr's Zeichnen des Textes aufruhfen
End Sub

