Attribute VB_Name = "mod_help"
Option Explicit
Public Declare Function ShellExecute Lib "shell32.dll" _
        Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal _
        lpOperation As String, ByVal lpFile As String, ByVal _
        lpParameters As String, ByVal lpDirectory As String, _
        ByVal nShowCmd As Long) As Long

'Applications Variablen und Konstanten
      Public Const D$ = vbNullString
      Public Const cYNull = -100000 ' Y nicht sichtbarer Bereich (Siehe Import & Chart !!!!)

'Menue Enums
      Public Enum enmSubM
          mnuDatei = 0
          mnuChart
          mnuExtras
          mnuFenster
          mnuHelp
          End Enum
          
      Public Enum smnuDatei
          ffnen = 0
          ffnen2 = 1
          Drucken = 3
          beenden = 5
          End Enum
          
      Public Enum smnuChart
          NewChart = 0
          clsChart = 2
          Refresh = 4
          kilChart = 6
          BColor = 8
          End Enum
          
      Public Enum smnuExtras
          Einstellungen = 0
          Automatik = 2
          AutomatikRun = 3
          End Enum
          
      Public Enum smnuFenster
          berlappend = 0
          nebeneinander
          bereinander
          anordnen
          nchste
          vorherg
          End Enum
          
      Public Enum smnuHelp
          Help = 0
          Info
          End Enum
          
      Public Enum TBar
          TBexit = 0
          TBopen
          TBprint
          TBcontrol
          TBchartnew
          TBchartcls
          TBchartdel
          TBchartref
          TBnext
          TBprev
          TBneben
          TBber
          TBkaskade
          TBauto
          TBrun
          TBFarbe
          TBopen2
          End Enum
          
'Menu control
      Public Sub InputProzess(enmM As enmSubM, Index As Integer)
      'On Error Resume Next
          Select Case enmM
            Case enmSubM.mnuDatei
                Select Case Index
                    Case smnuDatei.ffnen: MainProzess COpen
                    Case smnuDatei.ffnen2: MainProzess COpen2
                    Case smnuDatei.Drucken: MainProzess CDruck
                    Case smnuDatei.beenden: Exit_App
                End Select
            Case enmSubM.mnuChart
                Select Case Index
                    Case smnuChart.NewChart: MainProzess CNeu
                    Case smnuChart.clsChart: MainProzess CClear
                    Case smnuChart.Refresh: MainProzess CRefresh
                    Case smnuChart.kilChart: MainProzess CKill
                    Case smnuChart.BColor: MainProzess CHColor
                    
                End Select
            Case enmSubM.mnuExtras
                Select Case Index
                    Case smnuExtras.Einstellungen: MainProzess COptionen
                    Case smnuExtras.Automatik: Automat
                    Case smnuExtras.AutomatikRun: Automatik_start
                End Select
            Case enmSubM.mnuFenster
                Select Case Index
                    Case smnuFenster.berlappend: mdi.Arrange vbCascade
                    Case smnuFenster.nebeneinander: mdi.Arrange vbTileVertical
                    Case smnuFenster.bereinander: mdi.Arrange vbTileHorizontal
                    Case smnuFenster.anordnen: mdi.Arrange vbArrangeIcons
                    Case smnuFenster.nchste: FensterNextPrev True
                    Case smnuFenster.vorherg: FensterNextPrev False

                End Select
            Case enmSubM.mnuHelp
                Select Case Index
                    Case smnuHelp.Help: ShowHelp
                    Case smnuHelp.Info: ShowInfo
                End Select
          End Select
          mErrorMsg 1
          End Sub
          
'Toolbar - Menzuweisung
      Public Sub TBarProzess(ByVal Index As Integer)
          Select Case Index
              Case TBar.TBexit: InputProzess enmSubM.mnuDatei, smnuDatei.beenden
              Case TBar.TBopen: InputProzess enmSubM.mnuDatei, smnuDatei.ffnen
              Case TBar.TBopen2: InputProzess enmSubM.mnuDatei, smnuDatei.ffnen2
              Case TBar.TBprint:  InputProzess enmSubM.mnuDatei, smnuDatei.Drucken
              Case TBar.TBchartnew: InputProzess enmSubM.mnuChart, smnuChart.NewChart
              Case TBar.TBchartref:  InputProzess enmSubM.mnuChart, smnuChart.Refresh
              Case TBar.TBchartcls:  InputProzess enmSubM.mnuChart, smnuChart.clsChart
              Case TBar.TBchartdel:  InputProzess enmSubM.mnuChart, smnuChart.kilChart
              Case TBar.TBFarbe:  InputProzess enmSubM.mnuChart, smnuChart.BColor
              Case TBar.TBcontrol:  InputProzess enmSubM.mnuExtras, smnuExtras.Einstellungen
              Case TBar.TBauto:  InputProzess enmSubM.mnuExtras, smnuExtras.Automatik
              Case TBar.TBrun:  InputProzess enmSubM.mnuExtras, smnuExtras.AutomatikRun
              Case TBar.TBnext:  InputProzess enmSubM.mnuFenster, smnuFenster.nchste
              Case TBar.TBprev:  InputProzess enmSubM.mnuFenster, smnuFenster.vorherg
              Case TBar.TBneben:  InputProzess enmSubM.mnuFenster, smnuFenster.nebeneinander
              Case TBar.TBber:  InputProzess enmSubM.mnuFenster, smnuFenster.bereinander
              Case TBar.TBkaskade:  InputProzess enmSubM.mnuFenster, smnuFenster.berlappend
          End Select
      End Sub
      
'Toolbar initialisieren // Aktion in mdi.Toolbar_ButtonClick
      Public Sub TBar_ini()
          Dim s$, i
          On Error Resume Next
          With mdi
          For i = 0 To .TBar.Count - 1
              Select Case i
                  Case TBar.TBexit: s$ = "Programm beenden"
                  Case TBar.TBopen: s$ = "Document ffnen (je Tag eine Linie)"
                  Case TBar.TBopen2: s$ = "Document ffnen (alle Tage eine Linie)"
                  Case TBar.TBprint: s$ = "Diagramm drucken"
                  Case TBar.TBchartnew: s$ = "neues Diagramm"
                  Case TBar.TBchartref: s$ = "Diagramm neu Zeichnen"
                  Case TBar.TBchartcls: s$ = "Diagramm leeren"
                  Case TBar.TBchartdel: s$ = "Diagramm lschen"
                  Case TBar.TBFarbe: s$ = "Diagramm Hintergrund"
                  Case TBar.TBcontrol: s$ = "Einstellungen"
                  Case TBar.TBauto: s$ = "Automatik Ein/Aus"
                  Case TBar.TBrun: s$ = "Start Import"
                  Case TBar.TBnext: s$ = "Nchstes Fenster"
                  Case TBar.TBprev: s$ = "Vorhergehendes Fenster"
                  Case TBar.TBneben: s$ = "Fenster nebeneinander"
                  Case TBar.TBber: s$ = "Fenster bereinander"
                  Case TBar.TBkaskade: s$ = "Fenster berlappend"
              End Select
              .TBar(i).ToolTipText = s$
          Next
            .TBChk(enmTBChk.DATUM).ToolTipText = "Datum einblenden (betrifft immer 1.Linie)"
            .TBChk(enmTBChk.Legende).ToolTipText = "Legende einblenden"
            .TBChk(enmTBChk.Punkte).ToolTipText = "Messpunkte anzeigen"
'            .YScroll.Tag = "Y Legende Anzeigebereich"
'            .XScroll.Tag = "X Legende Anzeigebereich"
'            .HScroll.Tag = "X Legende Scrollen"
            .TBChk(enmTBChk.DATUM).Value = IIf(iniHDatum, 1, 0)
            .TBChk(enmTBChk.Legende).Value = IIf(iniLegende, 1, 0)
          End With
          End Sub

'Fenster NextPrev Funktion
      Public Sub FensterNextPrev(R As Boolean)
          Dim CKey%, Count%, i%, il%, CKeyname As String
          Dim Found As Boolean, iexit%
          On Error Resume Next
          If Forms.Count = 1 Then Exit Sub
          il% = Len(Forms(1).Caption)
          CKeyname = mdi.ActiveForm.Caption
          CKey = CInt(Mid$(CKeyname, il%))
          CKeyname = Mid$(CKeyname, 1, il% - 1) & "*"
          Count = Forms.Count - 1
Foundnext:
          If Count <= 1 Then Exit Sub
          iexit% = iexit% + 1
          If iexit% = 100 Then Exit Sub
          Select Case R
          Case True
                  CKey = CKey + 1
                  If CKey > 50 Then CKey = 0
          Case False
                  CKey = CKey - 1
                  If CKey < 0 Then CKey = 50
          End Select
          For i = 0 To Forms.Count - 1
               If Not Forms(i).Caption Like CKeyname Then GoTo w
               If CInt(Mid$(Forms(i).Caption, il%)) = CKey Then
               Forms(i).SetFocus: Found = True
               End If
w:       Next
        If Not Found Then GoTo Foundnext
      End Sub

'Fehlerbehandlung
      Public Function mErrorMsg(VISIBLE As Boolean, Optional s$) As Boolean
          If err.Number <> 0 Then
              mErrorMsg = True
              If VISIBLE Then MsgBox err.Description & " (" & err.Number & ") " _
              & s$, vbExclamation, "Laufzeitfehler"
              err.Number = 0
          Else
              mErrorMsg = False
          End If
          End Function

'String in Feld wandeln
      Public Function String2Array(ByRef Buffer$, ByRef sTrenn$, Optional dump%) As Variant
          Dim xArray(), Result&, l%, p%, z%
          Buffer$ = Trim(Buffer$): Result = Len(Buffer$): ReDim xArray(0): l = 1: z = 0
          Do While l <= Result: p = InStr(l, Buffer & sTrenn$, sTrenn$)
            If p = 0 Then Exit Do
            If z > 0 Then ReDim Preserve xArray(0 To z)
            xArray(z) = Mid$(Buffer, l + dump%, p - l): z = z + 1: l = p + 1
          Loop
          String2Array = xArray
          End Function

'Feld in String wandeln
      Public Function Array2String(ByRef ArrayF, ByRef sTrenn$) As String
          Dim i%: i = 1
          Array2String = ArrayF(0)
          Do While i <= UBound(ArrayF)
              Array2String = Array2String & sTrenn$ & ArrayF(i): i = i + 1
          Loop
          End Function

'Spalte in Datumstring wandeln
      Public Function ColToZeit(ByVal col%, Optional MPBeginn) As String
          Dim cNow As Date: cNow = "00:15" '#12:15:00 AM#   ' 15min Konstante
          Dim TBeginn As Date, TEnd As Date
          If col% < 0 Then Exit Function
          TBeginn = cNow * IIf(col% = 0, 95, col% - 1)
          TEnd = cNow * col%
          ColToZeit = Format(Str(TBeginn), "hh:mm") + "-" + _
                      Format(Str(TEnd), "hh:mm")
          End Function
          
' Zeit in Spalte wandeln  (00:00 - 23:45 = 0 - 95)
      Public Function ZeitToCol(ic%, ByVal Zeit$) As Boolean
          On Error Resume Next
          ZeitToCol = False
              Zeit$ = Format(Zeit$, "hh:mm")
              ic% = CByte(Left(Zeit$, 2)) * 4 + Fix(CByte(Right(Zeit$, 2)) / 15)
          If err.Number = 0 Then ZeitToCol = True
          End Function
          
          
          
          
          
          
          
          
          
          
          
          
          
          
          
          
          
