VERSION 5.00
Object = "{65E121D4-0C60-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCHRT20.OCX"
Begin VB.Form frmDiagramm 
   Caption         =   "Diagramm"
   ClientHeight    =   5595
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   12885
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmDiagramm.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5595
   ScaleWidth      =   12885
   StartUpPosition =   2  'Bildschirmmitte
   Begin MSChart20Lib.MSChart MSChart 
      Height          =   4215
      Left            =   0
      OleObjectBlob   =   "frmDiagramm.frx":1542A
      TabIndex        =   0
      Top             =   0
      Width           =   11175
   End
End
Attribute VB_Name = "frmDiagramm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim iAnsicht As Integer

Dim sArray() As String

Private Sub Form_Resize()
    MSChart.Height = frmDiagramm.ScaleHeight
    MSChart.Width = frmDiagramm.ScaleWidth
End Sub

Public Sub SInit(sWerte() As String, iTyp As Integer)
    'Die Werte bergeben
    sArray() = sWerte()
    
    'Die Ansicht definieren
    iAnsicht = iTyp
    
    'Diagrammansicht lschen
    SMSChart_Clear
    
    'Diagramansicht setzen
    MSChart.chartType = iAnsicht
    
    'Werte ins Diagramm schreiben
    SMSChart
    
    'Diagram Beschriften
    SMSChart_Beschriften
    
    'Diamgramm Fenster anzeigen
    frmDiagramm.Show 1
End Sub

Private Sub SMSChart()
    Dim Row As Integer
    Dim Column As Integer
    
    Dim i As Integer            'einfacher hochzhler
    Dim iStart As Integer

    'Start Zeit festlegen
    iStart = Format(Time, "h")

    'Hochzhler auf 1 setzen sonst "wird" dass sArray
    'von 0 aus gelesen.
    i = 1
   
    With MSChart
        'Spaltenanzahl bestimmen durch Combobox
        If iAnsicht = 1 Then
            .RowCount = 25
            .ColumnCount = 4
        Else
            .RowCount = 100
            .ColumnCount = 1
        End If
        
        For Row = 1 To .RowCount
            .Row = Row
            If iAnsicht = 1 Then
                For Column = 1 To 4
                    .Column = Column
                    .Data = sArray(2, i)
                    i = i + 1
                Next Column
            Else
                .Column = 1
                .Data = sArray(2, i)
                i = i + 1
            End If
        Next Row
    End With
End Sub

Private Sub SMSChart_Beschriften()

    Dim Row As Integer
    Dim i As Integer            'einfacher hochzhler
    Dim iStart As Integer
    Dim iStd As Integer
    
    Dim sStd As String
    
    'Start Zeit festlegen
    iStart = Format(Time, "h")
    
    i = 1
    With MSChart
        'Immer den ersten Datensatz nehmen
        .Column = 1
        For Row = 1 To .RowCount
            'Zuerst noch die Spalte definieren
            .Row = Row
            
            If iAnsicht = 1 Then
                iStd = (Row - 1)
            Else
                iStd = (Row - 1) / 4
            End If
                    
            'Wenn Startzeit und Zhler grsser 23 sind,
            'So wird ein ganzer Tag (24h) abgezogen.
            If iStd + iStart > 23 Then
                sStd = iStd + iStart - 24
            Else
                sStd = iStd + iStart
            End If
            
            If iAnsicht = 1 Then
                'Spalte anschreiben
                .RowLabel = Format(sStd, "00")
                
                .Column = 1
                .ColumnLabel = "xx:00"
                
                .Column = 2
                .ColumnLabel = "xx:15"
                
                .Column = 3
                .ColumnLabel = "xx:30"
                
                .Column = 4
                .ColumnLabel = "xx:45"
            Else
                If Row Mod 4 = 1 Then
                    'Spalte anschreiben
                    .RowLabel = Format(sStd, "00")
                Else
                    'Wenn die Spalte nicht die erste ist,
                    'so wird sie nicht angeschrieben
                    .RowLabel = ""
                End If
                .ColumnLabel = "xx:xx"
            End If
        Next Row
    End With
End Sub

Private Sub SMSChart_Clear()
    With MSChart
    
        'Spaltenanzahl und Datensatzanzahl auf 1 setzen:
        'Wenn die Diagrammansicht gendert wird, sieht es sonst komisch aus.
        .RowCount = 1
        .ColumnCount = 1
        
        'Spalte 1 und Datensatz 1 auswhlen
        .Row = 1
        .Column = 1
        
        'Mit nichts anschreiben
        .RowLabel = ""
        .ColumnLabel = "xx:xx"
        
        '"Keinen" Wert hineinschreiben
        .Data = ""
    End With
End Sub
