VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLineDiagramm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private colValues As Collection 'Collection fr Werte
Private mDest As PictureBox 'Ziel Picturebox
Private lMax As Long 'Maximaler wert
Dim dStart As Date 'Startzeit
Dim dEnd As Date 'Endzeit
Dim mLineColor As Long 'Linienfarbe
Dim mScaleColor As Long 'Koordinatensystemfarbe
Dim mTextColor As Long 'Textfarbe
Dim mFontName As String 'Schriftart
Dim mFontSize As Integer 'Schriftgrsse
Dim mColwidth As Single 'Spaltenabstand
Dim mDatum As Date 'Enddatum der Darstellung

Public Event Drawed()
Public Event NoData()

Public Property Get Datum() As Date
    Datum = mDatum
End Property

Public Property Let Datum(vNewValue As Date)
    mDatum = vNewValue
End Property

Public Property Get Colwidth() As Single
    Colwidth = mColwidth
End Property

Public Property Let Colwidth(vNewValue As Single)
    mColwidth = vNewValue
End Property

Public Property Get FontName() As String
    FontName = mFontName
End Property

Public Property Let FontName(vNewValue As String)
    mFontName = vNewValue
End Property

Public Property Get FontSize() As Integer
    FontSize = mFontSize
End Property

Public Property Let FontSize(vNewValue As Integer)
    mFontSize = vNewValue
End Property

Public Property Get LineColor() As Long
    LineColor = mLineColor
End Property

Public Property Let LineColor(vNewValue As Long)
    mLineColor = vNewValue
End Property

Public Property Get ScaleColor() As Long
    ScaleColor = mScaleColor
End Property

Public Property Let ScaleColor(vNewValue As Long)
    mScaleColor = vNewValue
End Property

Public Property Get TextColor() As Long
    TextColor = mTextColor
End Property

Public Property Let TextColor(vNewValue As Long)
    mTextColor = vNewValue
End Property

Public Property Set Destination(ByVal vData As PictureBox)
    
    Set mDest = vData
    
End Property

Public Sub Draw()
Attribute Draw.VB_UserMemId = 0
Dim I As Long
Dim dCounter As Date
Dim divH As Single 'Umrechnungsfaktor Y
Dim h As Single 'Diagrammhhe
Dim xx As Single 'Zwischenspeicher fr Linien X-Werte
Dim yy As Single 'Zwischenspeicher fr Linien Y-Werte
Dim mod1 As Long 'Teiler 1 fr Y-Skalierung
Dim mod2 As Long 'Teiler 2 fr Y-Skalierung
Dim sKey As String

    If colValues.count = 0 Then ReadData
        
    mDest.Cls
    
    'Picturebox einstellen
    With mDest
        .ForeColor = mTextColor
        .FontSize = mFontSize
        .FontName = mFontName
        .ScaleLeft = -1000
        .Width = mColwidth * (colValues.count + 1) - .ScaleLeft
        .ScaleTop = -(.ScaleHeight - 500)
    End With
    
    'Koordinatensystem zeichnen
    h = mDest.ScaleHeight - 600

    mDest.Line (0, 0)-(mDest.ScaleWidth + mDest.ScaleLeft - 100, 0), mScaleColor
    mDest.Line (0, 0)-(0, -(h)), mScaleColor
    
    'Skalierung festlegen
    divH = h / lMax
    
    If lMax <= 1000 Then
        mod1 = 100
        mod2 = 10
    ElseIf lMax > 1000 And lMax <= 5000 Then
        mod1 = 500
        mod2 = 50
    ElseIf lMax > 5000 And lMax <= 10000 Then
        mod1 = 1000
        mod2 = 100
    ElseIf lMax > 10000 And lMax <= 20000 Then
        mod1 = 2000
        mod2 = 200
    ElseIf lMax > 20000 And lMax <= 50000 Then
        mod1 = 5000
        mod2 = 500
    ElseIf lMax > 50000 And lMax <= 100000 Then
        mod1 = 10000
        mod2 = 1000
    ElseIf lMax > 100000 And lMax <= 200000 Then
        mod1 = 20000
        mod2 = 2000
    ElseIf lMax > 200000 And lMax <= 500000 Then
        mod1 = 50000
        mod2 = 5000
    End If
    
    'Skalierung zeichnen
    For I = 1 To lMax
        If I Mod mod1 = 0 Then
            mDest.Line (-100, -(I * divH))-(mDest.ScaleWidth + mDest.ScaleLeft - 100, -(I * divH)), mScaleColor
            mDest.CurrentY = mDest.CurrentY - (mDest.TextHeight(I) / 2)
            mDest.CurrentX = -200 - (mDest.TextWidth(I))
            mDest.Print I
        ElseIf I Mod mod2 = 0 Then
            
            mDest.Line (-50, -(I * divH))-(0, -(I * divH)), mScaleColor
        
        End If
    Next I
        
    'Daten schreiben
    I = 0
    dCounter = dStart
    xx = 0
    yy = 0
    Do While dCounter <= dEnd
        sKey = Format$(dCounter, "yyyymmdd hh:nn")
        I = I + 1
        'Teilstriche X-Achse zeichnen
        mDest.Line (I * mColwidth, 0)-(I * mColwidth, 100), mScaleColor
        
        If CLng(Format$(dCounter, "hhnn")) Mod 100 = 0 Then
            'Spalten beschriften
            mDest.CurrentX = (I * mColwidth) - (mDest.TextWidth(Format$(dCounter, "hh: nn")) / 2)
            mDest.Print Format$(dCounter, "hh:nn")
        End If
        
        'Dummy Eintrag checken
        If colValues(sKey) <> "-" Then
            'Linie zeichnen
            If xx <> 0 And yy <> 0 Then
                mDest.Line (xx, yy)-(I * mColwidth, -colValues(sKey) * divH), mLineColor
            End If
            xx = I * mColwidth
            yy = -colValues(sKey) * divH
        Else
            'Dummy! Zwischenspeicher auf 0 setzen
            xx = 0
            yy = 0
        End If
        
        dCounter = DateAdd("n", 15, dCounter)
    Loop
    
    RaiseEvent Drawed
    
End Sub

Private Sub ReadData()
Dim sTemp As String
Dim dCounter As Date
Dim Pos As Long
Dim sFileData As String

    dEnd = mDatum
        
    'dEnd auf 15 min. - Schritte korrigieren
    If Minute(dEnd) <= 15 Then
        dEnd = CDate(Format$(dEnd, "dd.mm.yyyy hh:00"))
    ElseIf Minute(dEnd) > 15 And Minute(dEnd) <= 30 Then
        dEnd = CDate(Format$(dEnd, "dd.mm.yyyy hh:15"))
    ElseIf Minute(dEnd) > 30 And Minute(dEnd) <= 45 Then
        dEnd = CDate(Format$(dEnd, "dd.mm.yyyy hh:30"))
    Else
        dEnd = CDate(Format$(dEnd, "dd.mm.yyyy hh:45"))
    End If
    
    'Startdatum/zeit auf dEnd - 24 Std. festlegen
    dStart = DateAdd("h", -24, dEnd)
    
    'Daten einlesen und in Collection schreiben
    sTemp = ""
    'Wenn dStart am Tag davor ist die Datei vom Vortag mit einlesen
    If CLng(Format$(dStart, "yyyymmdd")) < CLng(Format$(dEnd, "yyyymmdd")) Then
        sFileData = LoadFile(App.Path & "\" & Format$(dStart, "yyyymmdd") & ".txt")
        If sFileData = "" Then
            RaiseEvent NoData
            Exit Sub
        End If
        sTemp = Mid$(Replace(sFileData, vbCrLf, ";" & Format$(dStart, "yyyymmdd") & " "), 22)
    End If
    sFileData = LoadFile(App.Path & "\" & Format$(dEnd, "yyyymmdd") & ".txt")
    If sFileData = "" Then
        RaiseEvent NoData
        Exit Sub
    End If
    sTemp = sTemp & ";" & Mid$(Replace(sFileData, vbCrLf, ";" & Format$(dEnd, "yyyymmdd") & " "), 22)
    
    dCounter = dStart
    Do While dCounter <= dEnd
        If InStr(1, sTemp, Format$(dCounter, "yyyymmdd hh:nn")) > 0 Then
            'Eintrag gefunden Daten auslesen
            Pos = InStr(1, sTemp, Format$(dCounter, "yyyymmdd hh:nn")) + Len(Format$(dCounter, "yyyymmdd hh:nn")) + 1
            colValues.Add Trim(Mid$(sTemp, Pos, InStr(Pos, sTemp, ";") - Pos)), Format$(dCounter, "yyyymmdd hh:nn")
            If lMax < colValues.Item(Format$(dCounter, "yyyymmdd hh:nn")) Then lMax = colValues.Item(Format$(dCounter, "yyyymmdd hh:nn"))
        Else
            'Eintrag nicht gefunden Dummy Eintrag setzen
            colValues.Add "-", Format$(dCounter, "yyyymmdd hh:nn")
        End If
        dCounter = DateAdd("n", 15, dCounter)
    Loop

    

End Sub

Private Function LoadFile(mPath As String) As String
Dim tmp As String
Dim FN As String

    If FileExists(mPath) Then
        FN = FreeFile
        Open mPath For Binary As FN
        tmp = Space$(LOF(FN))
        Get FN, , tmp
        Close FN
        LoadFile = tmp
    End If
    
End Function

Private Sub Class_Initialize()
    
    Set colValues = New Collection
    mScaleColor = 0
    mTextColor = 0
    mLineColor = RGB(255, 0, 0)
    mFontName = "Tahoma"
    mFontSize = 7
    mColwidth = 400
    
End Sub

Private Sub Class_Terminate()
    
    Set colValues = Nothing
    
End Sub

Private Function FileExists(strPath As String) As Boolean
    On Error Resume Next
    FileExists = ((GetAttr(strPath) And (vbDirectory Or vbVolume)) = 0)
End Function
